<template>
  <transition
    enter-active-class="animated fadeIn"
    appear
  >
    <div class="w-full relative">
      <div
        class="absolute p-2 text-white"
        style="top: 1em; right: 1em;"
        :style="`background: ${contextAgreementColor}`"
      >
        {{ pattern.stateIntraAgreement }}
      </div>

      <h5 class="font-normal border-b-2 text-lg pb-4 mb-4 flex flex-col items-center">
        <p>
          {{ groupName }}
        </p>

        <div class="my-4">
          On:
        </div>

        <p>
          {{ context }}
        </p>
      </h5>

      <div class="flex-center">
        <div @click="select(selectedEntityPosition - 1)">
          <icon
            name="chevron-left"
            class="mr-1 cursor-pointer"
          />
        </div>

        <div
          v-for="(entity, index) of entities"
          :key="index"
          :class="{ 'grow': true, 'entity_square': true, 'entity_square--active': index == selectedEntityPosition }"
          :style="squareStyle(entity)"
          :title="makeTitle(entity)"
          @click="select(index)"
        />

        <div @click="select(selectedEntityPosition + 1)">
          <icon
            name="chevron-right"
            class="ml-1 cursor-pointer"
          />
        </div>
      </div>

      <div class="border-b-2 my-4" />

      <div
        v-if="selectedEntity"
        class="overflow-hidden relative"
      >
        <transition
          mode="out-in"
          :enter-active-class="[ 'animated fast fadeIn', headerAnimation.enter ].join(' ')"
          :leave-active-class="[ 'animated fast fadeOut', headerAnimation.leave ].join(' ')"
        >
          <div :key="selectedEntity.id">
            <EntityHeaderEUParl
              v-if="dataType == 'euparl'"
              class="my-4 text-center"
              :entity="selectedEntity"
            />

            <EntityHeaderCHUS
              v-else
              class="my-4 text-center"
              :entity="selectedEntity"
            />

            <div class="voters-grid">
              <template v-if="dataType == 'euparl'">
                <GroupMemberEUParl
                  v-for="m of group"
                  :key="m.person[0]"
                  :member="m"
                />
              </template>

              <template v-else>
                <GroupMemberCHUS
                  v-for="m of group"
                  :key="m.person[0]"
                  :member="m"
                />
              </template>
            </div>
          </div>
        </transition>
      </div>
    </div>
  </transition>
</template>

<style lang="postcss" scoped>
.entity_square {
  @apply block cursor-pointer;
  width: 20px;
  height: 20px;
  transition: all .2s;
}

.entity_square--active {
  box-shadow: inset 0 0 0 2px white;
}

.voters-grid {
  display: grid;
  grid: auto / auto auto;
  grid-gap: 1em;
}

.move {
  transition: transform .5s;
}
</style>

<script lang="tsx">
import { Vue, Component, Prop, Watch } from 'vue-property-decorator'
import { State } from 'vuex-class'

import 'vue-awesome/icons/chevron-left'
import 'vue-awesome/icons/chevron-right'
import Icon from 'vue-awesome/components/Icon.vue'

import axios from 'axios'
import _ from 'lodash/fp'

function colorPercentage ([r1, g1, b1], [r2, g2, b2], percentage) {
  const percent = (a, b) => a + (b - a) * percentage
  return [percent(r1, r2), percent(g1, g2), percent(b1, b2)]
}

function agreementColor (qual) {
  return qual >= 0
    ? colorPercentage([255, 237, 74], [0, 166, 90], qual)
    : colorPercentage([255, 237, 74], [221, 75, 57], Math.min(1, 2 * (Math.exp(-qual) - 1)))
}

function voteColorEUParl (vote) {
  switch (vote) {
    case 'For':
      return {
        background: 'bg-green-dark',
        text: 'text-white'
      }
    case 'Against':
      return {
        background: 'bg-red',
        text: 'text-white'
      }
    default:
      return {
        background: '',
        text: 'text-grey'
      }
  }
}

function voteColorCHUS (vote) {
  switch (vote) {
    case 'Yea':
      return {
        background: 'bg-green-dark',
        text: 'text-white'
      }
    case 'Nay':
      return {
        background: 'bg-red',
        text: 'text-white'
      }
    default:
      return {
        background: '',
        text: 'text-grey'
      }
  }
}

@Component
class EntityHeaderEUParl extends Vue {
  @Prop(Object) entity

  render () {
    const [groupAbstain, groupAgainst, groupFor] = this.entity.voteDistribution
    const groupMajorityVote = groupFor > groupAgainst ? 'For' : 'Against'
    const groupColors = voteColorEUParl(groupMajorityVote)
    const parliamentColors = voteColorEUParl(this.entity.majorityVote)
    const agreement = Math.round(100 * this.entity.krippendorffAlpha) / 100

    const groupVote = (
      <p class='text-left'>
    The group voted
        <span
          class={[ 'inline-block p-2 mx-1', groupColors.background, groupColors.text ]}>
          { groupMajorityVote }
        </span>
    this
    (For: { groupFor }, Against: { groupAgainst }, Abstain: { groupAbstain }).
    Intra-agreement: { agreement }
      </p>
    )

    return (
      <div>
        <h4 class='mb-2'>
          { this.entity.procedureTitle } (<a target='_blank' href={ this.entity.link }>link</a>)
        </h4>

        <p class=''>{ this.entity.issueType }</p>

        <p class='italic mb-4'>{ this.entity.voteDateDetailed }</p>

        <p class='text-left mb-2'>
      Parliament voted
          <span
            style='transition: background-color 1s'
            class={[ 'inline-block p-2 mx-1', parliamentColors.background, parliamentColors.text ]}>
            { this.entity.majorityVote }
          </span>
      this (For: { this.entity.majorityVoteDistribution[0] }, Against: { this.entity.majorityVoteDistribution[1] }, Abstain: { this.entity.majorityVoteDistribution[2] })
        </p>

        { groupVote }
      </div>
    )
  }
}

@Component
class EntityHeaderCHUS extends Vue {
  @Prop(Object) entity

  render (h) {
    const [nay, yea] = this.entity.majorityVoteDistribution
    const [groupNay, groupYea] = this.entity.voteDistribution
    const groupColors = voteColorCHUS(groupNay > groupYea ? 'Nay' : 'Yea')
    const parliamentColors = voteColorCHUS(this.entity.majorityVote)
    const agreement = Math.round(100 * this.entity.krippendorffAlpha) / 100

    let groupVote

    if (groupNay === groupYea) {
      groupVote = (
        <p class='text-left'>
    The group vote was tied (Nay: { groupNay }, Yea: { groupYea }).
    Intra-agreement: { agreement }
        </p>
      )
    } else {
      groupVote = (
        <p class='text-left'>
    The group voted
          <span
            class={[ 'inline-block p-2 mx-1', groupColors.background, groupColors.text ]}>
            { groupNay > groupYea ? 'Nay' : 'Yea' }
          </span>
    (Nay: { groupNay }, Yea: { groupYea }).
    Intra-agreement: { agreement }
        </p>
      )
    }

    return (
      <div>
        <h4 class='mb-2'>
          { this.entity.description }
        </h4>

        <p class=''>{ this.entity.issueType }</p>

        <p class='text-left mb-2'>
      Parliament voted
          <span
            class={[ 'inline-block p-2 mx-1', parliamentColors.background, parliamentColors.text ]}>
            { this.entity.majorityVote }
          </span>
      (Nay: { nay }, Yea: { yea })
        </p>

        { groupVote }
      </div>
    )
  }
}

const GroupMemberEUParl = Vue.extend({
  functional: true,

  props: {
    member: {
      type: Object,
      required: true
    }
  },

  render (h, { props }) {
    // eslint-disable-next-line no-unused-vars
    const {
      person: [
        id,
        name,
        country,
        party,
        group
      ],
      vote
    } = props.member

    const animatedVote = (
      <transition
        mode='out-in'
        enter-active-class={[ 'animated fast', 'fadeInLeft' ].join(' ')}
        leave-active-class={[ 'animated fast', 'fadeOutLeft' ].join(' ')}
      >
        <div
          key={vote}
          class={voteColorEUParl(vote).background + ' flex w-24 p-4 justify-center items-center'}
        >
          <span class={voteColorEUParl(vote).text}>
            { vote }
          </span>
        </div>
      </transition>
    )

    const details = (
      <div>
        <div>
          <p class='font-bold'>{ name }</p>
          <p class='italic'>{ party } — { group }</p>
          <p>{ country }</p>
        </div>
      </div>
    )

    return (
      <div key={ id } class='flex justify-between border-b mb-2'>
        { details }
        { animatedVote }
      </div>
    )
  }
})

const GroupMemberCHUS = Vue.extend({
  functional: true,

  props: {
    member: {
      type: Object,
      required: true
    }
  },

  render (h, { props }) {
    // eslint-disable-next-line no-unused-vars
    const {
      person: [
        id,
        party,
        stateICPSR,
        state,
        district,
        name
      ],
      vote
    } = props.member

    const animatedVote = (
      <transition
        mode='out-in'
        enter-active-class={[ 'animated fast', 'fadeInLeft' ].join(' ')}
        leave-active-class={[ 'animated fast', 'fadeOutLeft' ].join(' ')}
      >
        <div
          key={vote}
          class={voteColorCHUS(vote).background + ' flex w-24 p-4 justify-center items-center'}
        >
          <span class={voteColorCHUS(vote).text}>
            { vote }
          </span>
        </div>
      </transition>
    )

    const details = (
      <div>
        <div>
          <p class='font-bold'>{ name }</p>
          <p class='italic'>{ party } — { state }</p>
        </div>
      </div>
    )

    return (
      <div key={ id } class='flex justify-between border-b mb-2'>
        { details }
        { animatedVote }
      </div>
    )
  }
})

const headerAnimations = {
  left: { enter: 'fadeInLeft', leave: 'fadeOutRight' },
  right: { enter: 'fadeInRight', leave: 'fadeOutLeft' }
}

@Component({
  components: {
    EntityHeaderEUParl,
    EntityHeaderCHUS,
    GroupMemberEUParl,
    GroupMemberCHUS,
    Icon
  }
})
export default class DetailedResultsIntra extends Vue {
  get id () {
    return this.pattern.index
  }

  get groupName () {
    return this.pattern.group
  }

  get context () {
    return this.pattern.context
  }

  get group () {
    return this.aggregate(this.groupData, _.get(this.selectedEntity.id, this.groupOutcomes))
  }

  get selectedEntity () {
    if (_.isEmpty(this.entities)) {
      return null
    }

    switch (this.dataType) {
      case 'euparl': {
        const [
          id,
          voteDateDetailed,
          voteDate,
          dossierid,
          procedureTitle,
          issueType,
          procedureSubject,
          committee,
          procedureType,
          procedureSubtype,
          link,
          majorityVote,
          majorityVoteDistribution,
          krippendorffAlpha,
          nbVoters,
          voteDistribution
        ] = this.entities[this.selectedEntityPosition]

        return {
          id,
          voteDateDetailed,
          voteDate,
          dossierid,
          procedureTitle,
          issueType,
          procedureSubject,
          committee,
          procedureType,
          procedureSubtype,
          link,
          majorityVote,
          majorityVoteDistribution: JSON.parse(majorityVoteDistribution),
          krippendorffAlpha,
          nbVoters,
          voteDistribution: JSON.parse(voteDistribution)
        }
      }
      case 'chus': {
        const [ id, congress, year, description, idInCongress, billtype, topic, majorityVote, majorityVoteDistribution, krippendorffAlpha, nbVoters, voteDistribution ] = this.entities[this.selectedEntityPosition]

        return {
          id,
          congress,
          year,
          description,
          idInCongress,
          billtype,
          topic,
          majorityVote,
          majorityVoteDistribution: JSON.parse(majorityVoteDistribution),
          krippendorffAlpha,
          nbVoters,
          voteDistribution: JSON.parse(voteDistribution)
        }
      }
    }
  }

  @Prop(Object) pattern
  @Prop(String) dataType

  @State userID
  @State jobID

  entities = []
  groupData = []
  groupOutcomes = {}
  selectedEntityPosition = 0
  headerAnimation = headerAnimations.right

  voteColor

  @Watch('id')
  onIdChanged () {
    this.getDetailedResults(this.id)
  }

  mounted () {
    document.addEventListener('keyup', this.navigate)
    this.getDetailedResults(this.id)
  }

  destroyed () {
    document.removeEventListener('keyup', this.navigate)
  }

  makeTitle (entity) {
    return `${entity[7]}
  ${entity[6]}`
  }

  getDetailedResults (id) {
    axios.get(`/api/results/${this.userID}/${this.jobID}/${id}`)
      .then(({
        data: {
          entities,
          group,
          groupOutcomes
        }
      }) => {
        this.entities = _.compose([this.pattern.stateIntraAgreement === 'CONFLICTUAL' ? _.identity : _.reverse, _.sortBy(this.quality), _.dropRight(1), _.tail])(entities)
        this.groupData = _.tail(group)

        for (const voteId of this.entities.map(_.head)) {
          this.groupOutcomes[voteId as number] = {}
        }

        for (const [voteId, voterId, vote] of _.tail(groupOutcomes) as Array<[number, string, string]>) {
          this.groupOutcomes[voteId][voterId] = vote
        }
      })
  }

  select (i) {
    this.headerAnimation = _.get(i < this.selectedEntityPosition ? 'left' : 'right', headerAnimations)
    this.selectedEntityPosition = _.clamp(0, this.entities.length - 1, i)
  }

  navigate ({
    keyCode
  }) {
    const arrow = {
      left: 37,
      up: 38,
      right: 39,
      down: 40
    }

    switch (keyCode) {
      case arrow.left:
        this.select(this.selectedEntityPosition - 1)
        break
      case arrow.right:
        this.select(this.selectedEntityPosition + 1)
        break
    }
  }

  get contextAgreementColor () {
    return `rgb(${colorPercentage([221, 75, 57], [0, 166, 90], this.pattern.reliabilityContext).join(',')})`
  }

  aggregate (group, outcomes) {
    return _.compose([
      _.reverse,
      _.filter(_.get('vote')),
      _.sortBy(_.get('vote')),
      _.map((person) => ({
        person,
        vote: outcomes[person[0]]
      }))
    ])(group)
  }

  quality (entity) {
    switch (this.dataType) {
      case 'euparl': {
        return entity[13] - this.pattern.reliabilityRef
      }
      case 'chus': {
        return entity[9] - this.pattern.reliabilityRef
      }
    }
  }

  squareStyle (entity) {
    return `background: rgb(${agreementColor(this.quality(entity)).join(',')});`
  }
}
</script>
